//> program_type = HLSL
//> target = ps_2_0
//> entry = main
//> sampler_state source = { MINFILTER = LINEAR; MAGFILTER = LINEAR; };

//float div : register( c0 );
float depththres : register( c0 );
float2 offsets[4] : register( c1 );
sampler source : register( s0 );
sampler depth : register( s1 );

float4 main( float2 texCoord: TEXCOORD0 ) : COLOR
{
      float CenterDepth = tex2D( depth, texCoord );
      float4 sum = tex2D( source, texCoord );
      float total = 1.0f;
      
      float2 t[4];
      float4 diff;
      for (int i = 0; i < 4; i++)
      {
         t[i] = texCoord + offsets[i];
         float Depth = tex2D( depth, t[i] );
         diff[i] = Depth.x - CenterDepth.x;
      }
      
      diff = abs( diff );
      
      for (int i = 0; i < 4; i++)
      {
         float4 Sample = tex2D( source, t[i] );
         if( diff[i] < depththres )
         {
             sum += Sample;
             total++;
         }
      }
      
      return sum / total;
   
}


